#ifndef COORDINATE_SYSTEM_H
#define COORDINATE_SYSTEM_H

#include <qpainter.h>
#include <qpushbutton.h>
#include <qboxlayout.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <QTimer>
#include <QSlider>

#define centerX width() / 2
#define centerY height() / 2
#define angleSpinBox fields[4][0]
#define buttonsize 70

class CoordinateSystem : public QWidget {
  Q_OBJECT
	short step = 50;
  QDoubleSpinBox *fields[5][2];
	QSpinBox *spinBox;
  QPainter *painter;
	QTimer *timer;
	double currentAngle;
	double targetAngle;
	QPointF originalPoints[4];
	bool reverseRotation;
	double targetScale=1;
	QSlider *speedSlider;
	QLabel *warningLabel;
	bool isParallelogram();
	void paint(QPainter&);
	char currentStep = 0;
protected:
  void paintEvent(QPaintEvent*) override;
public:
  CoordinateSystem(QWidget *parent = nullptr);
private slots:
  void onButtonClick();
  void up();
	void rotateStep();
	void onRevButtonClick();
	void saveSvg();
	void showMatrix();
};

#endif // COORDINATE_SYSTEM_H
